#pragma once

struct SDL_Window;
struct SDL_Renderer;
struct SDL_Texture;

class CVideoPlayer
{
public:
	CVideoPlayer(int hWnd, int width, int height);
	~CVideoPlayer();

	void PlayVideo(int width, int height);


	unsigned char *video_frame_buffer_y_;
	unsigned char *video_frame_buffer_u_;
	unsigned char *video_frame_buffer_v_;
	int frame_y_pitch_;
	int frame_u_pitch_;
	int frame_v_pitch_;

	int     video_width_;
	int		video_height_;

private:
	int		wnd_handle_;

private:
	bool InitSDL(int hWnd, int width, int height);
	void UnInitSDL();
	void PlayVideoWithSDL(const unsigned char *pY, int yPitch, const unsigned char *pU, int uPitch, const unsigned char *pV, int vPitch);

private:
	SDL_Window		*sdl_window_;
	SDL_Renderer	*sdl_render_;
	SDL_Texture		*sdl_texture_;

	bool			sdl_init_ok_;
};