#ifndef __Z_CONN_MIC_TYPES_H__
#define __Z_CONN_MIC_TYPES_H__

#include <stdio.h>

#ifdef _WIN32
#define ZG_API_EXPORT __declspec(dllexport)
#define ZG_API_IMPORT __declspec(dllimport)
#else
#define ZG_API_EXPORT __attribute__ ((visibility("default")))
#define ZG_API_IMPORT 
#endif

#ifdef __cplusplus
#define ZG_C_API_EXPORT extern "C" ZG_API_EXPORT
#define ZG_C_API_IMPORT extern "C" ZG_API_IMPORT
#else
#define ZG_C_API_EXPORT ZG_API_EXPORT
#define ZG_C_API_IMPORT ZG_API_IMPORT
#endif

#ifdef ZG_SDK_EXPORTS		//need define this micro,when build dll, undefine this micro when use this dll
#define ZG_C_API ZG_C_API_EXPORT
#else
#define ZG_C_API ZG_C_API_IMPORT
#endif

typedef enum
{
	Z_START_PUBLISH_SUCCESS,	//start publish stream success
	Z_START_PUBLISH_FAILURE,

	Z_START_SUBSCRIBE_SUCCESS,	//start subscribe success
	Z_START_SUBSCRIBE_FAILURE,

	Z_DESTROY_HANDLE_OK,

}ZEventCode;

typedef enum
{
	Z_ROLE_TYPE_PUBLISH,
	Z_ROLE_TYPE_SUBSCRIBE,
}ZRoleType;

class GlobalObserver
{
public:
	virtual void OnGlobalEvent(int code, const char *context) = 0;
};

class ChannelObserver
{
public:
	virtual void OnChannelEvent(int handle, int code, const char *context) = 0;
	virtual void OnChannelVideoFrame(int handle, const unsigned char *pY, int yPitch, const unsigned char *pU, int uPitch, const unsigned char *pV, int vPitch, int width, int height) = 0;
	virtual void OnChannelAudioFrame(int handle, const void* audio_data, int bits_per_sample, int sample_rate, size_t number_of_channels, size_t number_of_frames, bool is_remote) = 0;
};

#endif