#pragma once

#include <WinSock2.h>
#include <string>
#include "ztypes.h"

#include "video_render_ex.h"

class DirectBaseClient : public CVideoRenderObserver
{
public:
	DirectBaseClient(int handle, std::string param, bool is_pusher, ChannelObserver *observer);
	virtual ~DirectBaseClient();

	int GetHandle() { return handle_; }
	std::string GetClientParam() { return client_param_; }

	virtual SOCKET GetAudioSocket() { return socket_audio_; }
	virtual SOCKET GetVideoSocket() { return socket_video_; }

	virtual void InputRtpRtcpData(SOCKET socket, char *buffer, int size) = 0;

	virtual void ParseParam();

public:
	/**
	 * CVideoRenderObserver
	 */
	virtual void OnVideoFrame(const unsigned char *pY, int yPitch, const unsigned char *pU, int uPitch, const unsigned char *pV, int vPitch, int width, int height);


protected:
	std::string		local_address_;
	int				local_port_video_;
	int				local_port_audio_;

	std::string		remote_address_;
	int				remote_port_video_;
	int				remote_port_audio_;

	SOCKET          socket_video_;
	SOCKET          socket_audio_;

protected:
	ChannelObserver	*observer_;

	CVideoRenderEx				*video_render_;

private:
	int         handle_;
	bool        is_pusher_;
	std::string client_param_;
};