#pragma once

#include <winsock2.h>
#include <Windows.h>

#include "call/audio_receive_stream.h"
#include "call/video_receive_stream.h"

#include "direct_base_client.h"
#include "rtprtcp_transport.h"
#include "video_render_ex.h"

class OffcnCall;

class DirectPullClient : public DirectBaseClient, 
						 public RtpRtcpTransportObserver
{
public:
    DirectPullClient(OffcnCall *offcn_call, int handle, std::string param, bool is_pusher, ChannelObserver *observer);
    ~DirectPullClient();

    bool StartPull();
    bool StopPull();

	virtual void InputRtpRtcpData(SOCKET socket, char *buffer, int size);

public:
    /**
     * RtpRtcpTransportObserver
     */
    virtual bool SendRtpRtcpData(RtpRtcpTransport *transport, const uint8_t *data, size_t length, bool is_rtcp);

private:
    RtpRtcpTransport    *transport_audio_;
	RtpRtcpTransport    *transport_video_;

private:
    OffcnCall                   *offcn_call_;
    webrtc::AudioReceiveStream  *audio_receive_stream_;
	webrtc::VideoReceiveStream	*video_receive_stream_;
};