#pragma once

#include <winsock2.h>
#include <Windows.h>

#include <string>

#include "call/audio_send_stream.h"
#include "call/video_send_stream.h"

#include "direct_base_client.h"
#include "rtprtcp_transport.h"
#include "media/base/videocapturer.h"

#include "video_render_ex.h"

class OffcnCall;

class DirectPushClient : public DirectBaseClient, public RtpRtcpTransportObserver
{
public:
    DirectPushClient(OffcnCall *offcn_call, int handle, std::string param, bool is_pusher, ChannelObserver *observer);
    ~DirectPushClient();

    bool StartPush();
    bool StopPush();

    virtual void InputRtpRtcpData(SOCKET socket, char *buffer, int size);

public:
    /**
     * RtpRtcpTransportObserver
     */
    virtual bool SendRtpRtcpData(RtpRtcpTransport *transport, const uint8_t *data, size_t length, bool is_rtcp);

private:
    RtpRtcpTransport        *transport_video_;
    RtpRtcpTransport        *transport_audio_;

private:
    OffcnCall                                       *offcn_call_;
    std::unique_ptr<cricket::VideoCapturer>         video_capturer_;
    std::unique_ptr<webrtc::VideoEncoderFactory>	video_encoder_factory_;
    webrtc::AudioSendStream                         *audio_send_stream_;
    webrtc::VideoSendStream                         *video_send_stream_;
};