#pragma once

#include <winsock2.h>
#include <windows.h>

#include "call/video_receive_stream.h"
#include "call/video_send_stream.h"

#include "media/engine/webrtcvideocapturerfactory.h"
#include "modules/video_capture/video_capture_factory.h"

namespace offcn {

	class EncoderSetting : public webrtc::VideoEncoderConfig::VideoStreamFactoryInterface
	{
	public:
		static const size_t kMaxNumberOfStreams = 1;
		static const int kMaxBitratePerStream[];
		static const int kDefaultMinBitratePerStream[];

		static void GetVideoCodecObj(webrtc::VideoCodec &codec, webrtc::VideoCodecType type);
		static void GetVideoEncoderConfig(webrtc::VideoEncoderConfig &config, webrtc::VideoCodec &codec);

	public:
		std::vector<webrtc::VideoStream> CreateEncoderStreams(int width, int height, const webrtc::VideoEncoderConfig &encoder_config);
	};

	void FillEncoderConfiguration(webrtc::VideoCodecType codec_type, size_t num_streams, webrtc::VideoEncoderConfig* configuration);

	std::unique_ptr<cricket::VideoCapturer> OpenVideoCaptureDevice();
}