#include "libmediacore.h"
#include "client_manager.h"

namespace offcn
{
	static ClientManager *client_manager_ = NULL;

	ZG_C_API void Initialize(GlobalObserver *observer)
	{
		if (client_manager_ == NULL)
		{
			client_manager_ = new ClientManager(observer);
			client_manager_->Init();
		}
	}

	ZG_C_API void UnInitialize()
	{}

	ZG_C_API void SetParam(const char *param)
	{}

	ZG_C_API int CreateRoleHandle(const char *param, ChannelObserver *observer, ZRoleType type)
	{
		if (type == Z_ROLE_TYPE_PUBLISH)
		{
			return client_manager_->CreatePushHandle(param, observer);
		}
		else
		{
			return client_manager_->CreatePullHandle(param, observer);
		}
		return 0;
	}
	ZG_C_API void DestroyRoleHandle(int handle, ZRoleType type)
	{
		if (type == Z_ROLE_TYPE_PUBLISH)
		{
			client_manager_->DestroyPushHandle(handle);
		}
		else
		{
			client_manager_->DestroyPullHandle(handle);
		}
	}
	ZG_C_API void StartPublish(int handle)
	{
		client_manager_->StartPush(handle);
	}
	ZG_C_API void StopPublish(int handle)
	{
		client_manager_->StopPush(handle);
	}

	ZG_C_API void StartSubscribe(int handle)
	{
		client_manager_->StartPull(handle);
	}
	ZG_C_API void StopSubscribe(int handle)
	{
		client_manager_->StopPull(handle);
	}
}