#pragma once

#include <WinSock2.h>
#include <thread>
#include <mutex>
#include <map>

class NetDataReceiveObserver
{
public:
    virtual void NetDataReceiveGetData(SOCKET socket, int handle_id, std::string ip, int port, const char *buffer, int size) = 0;
};

class NetDataReceive
{
public:
    NetDataReceive(NetDataReceiveObserver *observer);
    ~NetDataReceive();

    bool Start();
    bool Stop();

    bool AddConnection(SOCKET socket, int handle);
    bool RemoveConnection(SOCKET socket);

private:
    static void RecvThreadCallBack(void *obj);
    void RecvThread();

private:
    bool        thread_running_;
    std::thread recv_thread_;

private:
    std::mutex  mutex_connections_;
    typedef std::map<SOCKET, int> ConnectionMapType;
    ConnectionMapType all_connections_;

private:
    NetDataReceiveObserver  *observer_;
};