#pragma once

#include "api/call/transport.h"

class RtpRtcpTransport;

class RtpRtcpTransportObserver
{
public:
    virtual bool SendRtpRtcpData(RtpRtcpTransport *transport, const uint8_t *data, size_t length, bool is_rtcp) = 0;
};

class RtpRtcpTransport : public webrtc::Transport
{
public:
    RtpRtcpTransport(RtpRtcpTransportObserver *observer);
    ~RtpRtcpTransport();

    bool SendRtp(const uint8_t *data, size_t length, const webrtc::PacketOptions &options);
	bool SendRtcp(const uint8_t *data, size_t length);

private:
    RtpRtcpTransportObserver *observer_;
};