#ifndef __VIDEO_RENDER_EX_H__
#define __VIDEO_RENDER_EX_H__

#include "api/mediastreaminterface.h"
#include "api/video/video_frame.h"

class CVideoRenderObserver
{
public:
	virtual void OnVideoFrame(const unsigned char *pY, int yPitch, const unsigned char *pU, int uPitch, const unsigned char *pV, int vPitch, int width, int height) = 0;
};

class CVideoRenderEx : public rtc::VideoSinkInterface<webrtc::VideoFrame>
{
public:
	CVideoRenderEx(webrtc::VideoTrackInterface *track, CVideoRenderObserver *observer);
	virtual ~CVideoRenderEx();

public:
	/**
	 *	Add self to video track
	 */
	void AddVideoSink();
	/**
	 *	Remove self from video track
	 */
	void RemoveVideoSink();

public:
	//
	// VideoSinkInterface implementation
	//
	void OnFrame(const webrtc::VideoFrame& video_frame) override;

private:
	rtc::scoped_refptr<webrtc::VideoTrackInterface> render_track_;

private:
	CVideoRenderObserver	*observer_;
};
#endif